unit Unit10;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  RVStyle, RVScroll, RichView, RVEdit, RVGrHandler, StdCtrls, Jpeg, PngImage,
  GifImg, RVGifAnimate2007, RVItem, CRVData, IdIOHandler, IdIOHandlerSocket,
  IdIOHandlerStack, IdSSL, IdSSLOpenSSL;

type
  TfrmMain = class(TForm)
    txtSource: TEdit;
    Button1: TButton;
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    IdHTTP1: TIdHTTP;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    txtAlt: TEdit;
    Label3: TLabel;
    txtHint: TEdit;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function DownloadImage(const URL: String): TGraphic;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.Button1Click(Sender: TObject);
var Gr: TGraphic;
begin
  txtSource.Enabled := False;
  Button1.Enabled := False;
  RichViewEdit1.Enabled := False;
  Button1.Caption := 'Downloading';
  Screen.Cursor := crHourGlass;
  try
    Gr := DownloadImage(txtSource.Text);
    if Gr=nil then
       exit;
    RichViewEdit1.TopLevelEditor.BeginUndoGroup(rvutInsert);
    RichViewEdit1.TopLevelEditor.SetUndoGroupMode(True);
    try
      if RichViewEdit1.InsertPicture('', gr, rvvaBaseline) then
        // RichViewEdit1.SetCurrentItemExtraIntProperty(rvepSpacing, 0, True);
        RichViewEdit1.SetCurrentItemExtraStrProperty(rvespImageFileName, txtSource.Text, True);
        RichViewEdit1.SetCurrentItemExtraStrProperty(rvespAlt, txtAlt.Text, True);
        RichViewEdit1.SetCurrentItemExtraStrProperty(rvespHint, txtHint.Text, True);
    finally
      RichViewEdit1.TopLevelEditor.SetUndoGroupMode(False);
    end;
  finally
     Button1.Caption := 'Insert';
     txtSource.Enabled := True;
     Button1.Enabled := True;
     RichViewEdit1.Enabled := True;
     Screen.Cursor := crArrow;
  end;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
    RichViewEdit1.DeleteUnusedStyles(True, True, True);
    RichViewEdit1.ClearUndo;
    RichViewEdit1.SaveHTMLEx(SaveDialog1.FileName, 'Example', '', '', '', '',
      [rvsoUTF8, rvsoUseCheckpointsNames, rvsoUseItemImageFileNames]);
  end;
end;

function TfrmMain.DownloadImage(const URL: String): TGraphic;
var
  Stream: TMemoryStream;
begin
  Result := nil;
  if (Copy(LowerCase(URL), 1, 7)<>'http://') and
    (Copy(LowerCase(URL), 1, 8)<>'https://') then begin
    Application.MessageBox('"http://" or "https://" is required', 'Error');
    exit;
  end;
  Stream := TMemoryStream.Create;
  try
    try
      IdHTTP1.Get(URL, Stream);
    except
      Application.MessageBox('Cannot download the image', 'Error');
      FreeAndNil(Stream);
    end;
    if Stream<>nil then
    begin
      Stream.Position := 0;
      Result := RVGraphicHandler.LoadFromStream(Stream);
      if Result = nil then
        Application.MessageBox('Invalid image or unknown image format', 'Error');
    end;
  finally
    Stream.Free;
  end;
end;

end.
